#line 1 "P:/_Electronique_/# LibStock #/# MikroC_Channel_0_1_2_3_on_LCD #/ADC_Test6.c"
#line 22 "P:/_Electronique_/# LibStock #/# MikroC_Channel_0_1_2_3_on_LCD #/ADC_Test6.c"
sbit Chip_Select_Direction at TRISC0_bit;
sbit Chip_Select at RC0_bit;


sbit LCD_RS at RB5_bit;
sbit LCD_EN at RB7_bit;

sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB2_bit;
sbit LCD_D6 at RB4_bit;
sbit LCD_D7 at RB6_bit;

sbit LCD_RS_Direction at TRISB5_bit;
sbit LCD_EN_Direction at TRISB7_bit;

sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB2_bit;
sbit LCD_D6_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB6_bit;


unsigned int measurement, lastValue;

void Init()
{
 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);


 measurement = 0;


 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64,
 _SPI_DATA_SAMPLE_END,
 _SPI_CLK_IDLE_LOW,
 _SPI_LOW_2_HIGH);

 Chip_Select_Direction= 0;
 Chip_Select= 0;
}

unsigned int getADC(unsigned short channel)
{

 unsigned int tmp;
 Chip_Select = 0;
 SPI1_Write(0x06);
 channel = channel << 6;
 tmp = SPI1_Read(channel) & 0x0F;
 tmp = tmp << 8;
 tmp |= SPI1_Read(0);
 Chip_Select = 1;
 return tmp;
}

void ProcessValue(unsigned int pv, unsigned short channel)
{
 char i, lcdRow, lcdCol;

 if(channel < 2) lcdRow=1;
 else lcdRow=2;
 if(channel%2 > 0 ) lcdCol=13;
 else lcdCol=4;



 i = pv /1000 + 48;
 Lcd_Chr(lcdRow,lcdCol, i);
 pv %= 1000;
 i = pv /100 + 48;
 Lcd_Chr(lcdRow,lcdCol+1, i);
 pv %= 100;
 i = pv /10 + 48;
 Lcd_Chr(lcdRow,lcdCol+2, i);
 pv %= 10;
 i = pv + 48;
 Lcd_Chr(lcdRow,lcdCol+3, i);
}



void main()
{

 Init();

 Lcd_Out(1,1,"Build : "  "22:55:27" );
 Lcd_Out(2,1,"le "  "Jul  4 2013" );

 Delay_ms(2000);

 Lcd_Out(1,1,"C0=      C1=");
 Lcd_Out(2,1,"C2=      C3=");

 while(1)
 {
 measurement = getADC(0);
 ProcessValue(measurement,0);
 Delay_ms(100);
 measurement = getADC(1);
 ProcessValue(measurement,1);
 Delay_ms(100);
 measurement = getADC(2);
 ProcessValue(measurement,2);
 Delay_ms(100);
 measurement = getADC(3);
 ProcessValue(measurement,3);
 Delay_ms(100);
 }
}
